Description

Hi,

Seems that the issues Rest API is somehow broken in 1.2.1 version.

Hitting the appropriate url on both xml or json entry points returns a HTML page instead of xml or json payload.

Note that the projects API does not have this behavior, as it returns the expected xml or json payload.

Also note that the issue does not seem related to the http front-end as it is reproducible on both rack and apache2/passenger setups.

Steps to reproduce

DO : make sure you have a project with some issues, and an API key for the a given user

DO : execute :

    curl -X GET http://<myserver>/redmine/issues.json?key=<key>

OBSERVE : the log indicates :

Processing IssuesController#index to xml (for ::1 at 2011-07-22 15:18:41) [GET]

  Parameters: {"format"=>"xml", "action"=>"index", "controller"=>"issues", "key"=>"xxxxxxxxxxxxx"}

Rendering issues/index

Completed in 201ms (View: 144, DB: 10) | 200 OK [http://localhost/redmine/issues.xml?key=xxxxxxxxx

xxxx]

EXPECT  : an xml payload is returned

OBSERVE : curl returns the "issues search" page part in HTML format :

   <div class="contextual">

   </div>

   <h2>Issues</h2>

   ....

 

Environment

Fresh Redmine 1.2.1 installation from downloaded tarball

Rails 2.3.11

Ruby 1.8.7

MySQL 5.1.49

Debian Squeeze

Associated revisions

Revision 6309 - 2011-07-23 21:45 - Jean-Philippe Lang

Respond with errors and appropriate content type on /issues API calls with invalid query params (#8883).

Revision 7024 - 2011-09-02 01:40 - Toshi MARUYAMA
respond nothing in case of content type is not html with invalid query params (#8883, #6317).

Revision 7025 - 2011-09-02 01:41 - Toshi MARUYAMA

add test to respond nothing in case of content type is html with invalid query params (#8883, #6317).

Revision 7026 - 2011-09-02 01:42 - Toshi MARUYAMA

add test to respond nothing in case of content type is not html with invalid query params (#8883, #6317).

History

#1 - 2011-07-22 15:20 - zlatko arifhodzic

Sorry, in the Steps To Reproduce section there is an inconsistency with the logs.

It should stated :

curl -X GET http://<myserver>/redmine/issues.xml?key=<key>

 Nerveless, I tested both xml and json modes and both provide html instead of the API response.

#2 - 2011-07-23 16:10 - Jean-Philippe Lang

Can you attach the full html response please?

#3 - 2011-07-23 18:39 - zlatko arifhodzic

Jean-Philippe Lang wrote:

Can you attach the full html response please?

 Not before monday, but I'll post the full response as soon as I get my hands on it.

Also note that only the index/list returns the html rendering. Getting an issue by ID (http://server/redmine/issues/&lt;ID&gt;.json) or even

adding/updating issues works fine.

#4 - 2011-07-23 21:26 - Jean-Philippe Lang

I think you're getting html because something goes wrong with your issue query.

See source:/trunk/app/controllers/issues_controller.rb@6210#L99

I have to fix this behaviour.

#5 - 2011-07-25 11:53 - zlatko arifhodzic

- File response-before-patched.out added

- File response-patched.out added

Hi, I've tried to patch the 1.2.1 according to the commit in trunk, but the issue persists.

I've attached the responses obtained with and without the patch, and they are both quite the same ( a couple of velues differ, but the result is a html

div not json or xml ).

#6 - 2011-07-25 13:03 - Etienne Massip

Are you sure you don't have any plugins which may affect the normal behavior ?

#7 - 2011-07-25 13:53 - zlatko arifhodzic

Well I do have a number of plugins, however I'm unable to indicate whenever they can interfere with the Rest API.

Here is the list of installed plugins :

Redmine Charts v0.1.0

Redmine Extended Spent Time plugin v0.0.2

Redmine Issue Due Date v0.1.0

Redmine Issue History plugin v0.0.1

Redmine Show Descriptions plugin v0.0.4

Redmine Work Time plugin v0.1.2

Most of them provide additional features, I'm not sure whenever they change the default issue listing behavior using the API.

But I can deploy a new instance of Redmine 1.2.1 from SVN skip the plugins, and do some tests on a fresh install. I'll try to do it today, tomorrow
morning in worst case.

#8 - 2011-07-26 14:11 - zlatko arifhodzic

You're right Etienne, seems that some of the installed plugins break the Rest API.

I tested a fresh install from SVN and the API issue listing seem to be working !

Now I'll try to go through the installation each of the plugins and try to determine the causing the error ...

#9 - 2011-07-26 18:47 - zlatko arifhodzic

- Status changed from New to Resolved

And the winner is :

Redmine Show Descriptions plugin v0.0.4

Once removed I can use the API to list the issues !

My apologies for reporting the issue and not proceeding sequentially on install time.

#10 - 2011-08-15 11:17 - Etienne Massip

- Status changed from Resolved to Closed

- Resolution set to Invalid

#11 - 2011-12-15 00:11 - Terence Mill

Done a fix, Will be available soon on https://github.com/cforce/redmine_show_descriptions

zlatko arifhodzic wrote:

And the winner is :

Redmine Show Descriptions plugin v0.0.4

Once removed I can use the API to list the issues !

My apologies for reporting the issue and not proceeding sequentially on install time.

Files

response-before-patched.out 30.9 KB 2011-07-25 zlatko arifhodzic

response-patched.out 30.9 KB 2011-07-25 zlatko arifhodzic
